#define ASCII_A 65
#define ASCII_Z 90
#define ASCII_a 97
#define ASCII_z 132

//Support accented characters using these two lists.
var/list
	special_uppercase=list(138,140,142,159,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,216,217,218,219,220,221)
	special_lowercase=list(154,156,158,161,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,248,249,250,251,252,253,254,255)

proc
	_letter_isLower(letter)
		var/ascii_letter
		//Takes either a letter or ascii as an argument
		if(istext(letter))
			ascii_letter=text2ascii(letter)
		else
			ascii_letter=letter
		if((ascii_letter >= ASCII_a && ascii_letter <= ASCII_z) || (ascii_letter in special_lowercase))
			return 1
		return 0

	_letter_isUpper(letter)
		var/ascii_letter
		//Takes either a letter or ascii as an argument
		if(istext(letter))
			ascii_letter=text2ascii(letter)
		else
			ascii_letter=letter
		if((ascii_letter >= ASCII_A && ascii_letter <= ASCII_Z) || (ascii_letter in special_uppercase))
			return 1
		return 0

	//An internal version of isLetter() that only takes 1-character-long strings.
	_is_letter(letter)
		ASSERT(istext(letter) || isnum(letter))
		if((istext(letter) && length(letter) != 1) || (isnum(letter) && length(ascii2text(letter)) != 1))
			CRASH("_is_letter() was called with length(letter) != 1. _is_letter() is only meant to be called with a one-character argument.")
		if(_letter_isUpper(letter) || _letter_isLower(letter))
			return 1
		return 0

	isAlphabet(string)
		for(var/i=1,i <= length(string),i++)
			if(!_is_letter(copytext(string,i,i+1)))
				return 0
		return 1

	//Disregarding all non-letter characters, tests if a string is COMPLETELY uppercase.
	isUpper(string)
		ASSERT(istext(string))
		for(var/i=1,i <= length(string),i++)
			var/ascii_letter=text2ascii(string,i)
			if(_letter_isLower(ascii_letter))
				return 0
		return 1

	//Disregarding all non-letter characters, tests if a string is COMPLETELY lowercase.
	isLower(string)
		ASSERT(istext(string))
		for(var/i=1,i <= length(string),i++)
			var/ascii_letter=text2ascii(string,i)
			if(_letter_isUpper(ascii_letter))
				return 0
		return 1